(function ($) {

    "use strict";

    /** trim polyfill */
    if (!String.prototype.trim) {
        (function () {
            // Вырезаем BOM и неразрывный пробел
            var rtrim = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g;
            String.prototype.trim = function () {
                return this.replace(rtrim, '');
            };
        })();
    }

    /**  main object */

    var theme = {};

    theme.$body = $("body");
    theme.$window = $(window);
    theme.$header = $("#site-header");
    theme.$mobileHeaderBar = $("#mobile-header-bar");
    theme.$footer = $("#site-footer");
    theme.$wrapper = $("#main-wrapper");
    theme.$headerControls = $("#header-controls");
    theme.$headerSidebar = $("#header-sidebar");
    theme.$headerSidebarBtn = $("#header-sidebar-btn");
    theme.$headerSidebarBtnMobile = $("#header-sidebar-btn-mobile");
    theme.$headerSearchBtn = $("#header-search-btn");
    theme.$headerSearchBtnMobile = $("#header-search-btn-mobile");
    theme.$headerCartBtn = $("#header-cart-btn");
    theme.$headerCartBtnMobile = $("#header-cart-btn-mobile");
    theme.$titleCrumbs = $(".title-crumbs");
    theme.$menuWrap = $("#menu-wrap");
    theme.$searchWrap = $("#site-search-fixed-wrap");
    theme.$cartWrap = $("#site-cart-fixed-wrap");
    theme.$headerToggle = $("#header-toggle");
    theme.$headerToggleMobile = $("#header-toggle-mobile");

    theme.mobileMenu = false;
    theme.options = window.themeOptions || {};

    theme.retina = window.devicePixelRatio > 1;

    theme.initGGTSliders = function () {
        var $body = this.$body,
            $sliders = $(".ggt-slider");

        if (!$sliders.length) {
            return;
        }

        $sliders.each(function () {
            var $slider = $(this),
                options = {},
                $progress = $slider.find(".slider-progress"),
                $progressValue = $progress.find(".progress-value"),
                autoplayPaused = false,
                autoplayStopped = false,
                $header = $("#site-header"),
                $slides = $slider.find(".ggt-slide"),
                $sliderPlayPause = $slider.find(".slider-btn"),
                current = 0,
                total = $slides.length,
                ap = false,
                $pagination,
                $paginationWrap = $slider.find(".ggt-pagination-wrap"),
                $points,
                $navigation,
                $prev,
                $next
                ;

            options["autoplay"] = $slider.attr("data-autoplay") || false;
            options["autoplayInterval"] = Number($slider.attr("data-autoplay-interval")) || 7000;
            options["showPagination"] = $slider.attr("data-pagination") || false;
            options["showNavigation"] = $slider.attr("data-navigation") || false;

            function next() {
                if (current == total - 1) {
                    goTo(0);
                }
                else {
                    goTo(current + 1)
                }
            }

            function prev() {
                if (current == 0) {
                    goTo(total - 1);
                }
                else {
                    goTo(current - 1)
                }
            }

            function goTo(newCurrent) {

                var $oldCurrent = $slides.eq(current),
                    $newCurrent = $slides.eq(newCurrent);

                $oldCurrent.removeClass("current").addClass("slide-out");
                $newCurrent.addClass("current").addClass("slide-in");
                $slider.removeClass("section-" + $oldCurrent.attr("data-skin")).addClass("section-" + $newCurrent.attr("data-skin"));
                if ($body.hasClass("header-transparent")) {
                    $header.removeClass("section-" + $oldCurrent.attr("data-skin")).addClass("section-" + $newCurrent.attr("data-skin"));
                }
                setTimeout(function () {
                    $oldCurrent.removeClass("slide-out");
                    $newCurrent.removeClass("slide-in");
                }, 1200);
                current = newCurrent;
                maybeResetPagination(newCurrent);
                resetProgress();
            };

            function initNavigation() {
                if (options["showNavigation"]) {
                    $navigation = $slider.find(".ggt-slider-nav");
                    $prev = $navigation.find(".ggt-prev");
                    $next = $navigation.find(".ggt-next");

                    $prev.on("click", function () {
                        prev();
                        maybeResetAutoplay();
                        return false;
                    });

                    $next.on("click", function () {
                        next();
                        maybeResetAutoplay();
                        return false;
                    })
                }
            }

            function initPagination() {
                if (options["showPagination"]) {
                    $pagination = $slider.find(".ggt-slider-pagination");
                    $points = $pagination.find(".ggt-point");

                    $points.on("click", function () {
                        $points.removeClass("current");
                        $(this).addClass("current");
                        goTo($(this).index());
                        maybeResetAutoplay();
                        return false;
                    });
                }
            }

            function maybeResetAutoplay() {
                if (options["autoplay"] && $(window).width() >= 768) {
                    if (autoplayStopped) {
                        return;
                    }
                    clearInterval(ap);
                    ap = setInterval(next, options["autoplayInterval"]);
                }
            }

            $paginationWrap.hoverIntent(function () {
                    $progressValue.stop();
                    clearInterval(ap);
                    autoplayPaused = true;
                },
                function () {
                    autoplayPaused = false;
                    maybeResetAutoplay();
                    resetProgress();
                });

            $sliderPlayPause.off("click");
            $sliderPlayPause.on("click", function () {
                var $btn = $(this);

                if ($btn.hasClass("slider-play")) {
                    $btn.removeClass("slider-play").addClass("slider-pause");
                    autoplayStopped = false;
                    autoplayPaused = false;
                    maybeResetAutoplay();
                    resetProgress();
                }
                else {
                    $progressValue.stop();
                    clearInterval(ap);
                    autoplayStopped = true;
                    $btn.removeClass("slider-pause").addClass("slider-play");
                }
                return false;
            });

            function maybeResetPagination(current) {
                if (options["showPagination"]) {
                    $points.removeClass("current");
                    $points.eq(current).addClass("current");
                }
            }

            function resetProgress() {
                if (options["autoplay"] && $(window).width() >= 768) {
                    if (autoplayPaused || autoplayStopped) {
                        return;
                    }
                    $progressValue.stop().css("width", "0px");
                    $progressValue.animate({width: "100%"}, options["autoplayInterval"], "linear", function progressOnComplete() {
                        $progressValue.css("width", "0px");
                    });
                }
                else {
                    $progress.hide();
                }
            }

            initNavigation();
            initPagination();

            if (options["autoplay"] && $(window).width() >= 768) {
                ap = setInterval(next, options["autoplayInterval"]);
            }

            resetProgress();

            $slides.eq(0).addClass("current");
            $slider.addClass("section-" + $slides.eq(0).attr("data-skin"));
            maybeResetPagination(0);
        });
    };

    /** header toggle handler */
    theme.headerToggleInit = function () {

        var $morph,
            $svg,
            s,
            path,
            initialPath,
            pathOpen,
            headerOpen = false,
            handleSvg = function () {
            };

        if ((this.options.header_position == "left" || this.options.header_position == "right") && this.options.vertical_header_bg_type == "color") {
            $morph = $(".morph-shape");
            if ($morph.length) {
                $svg = $morph.find('svg');
                s = Snap($svg.get(0));
                path = s.select("path");
                initialPath = path.attr("d");
                pathOpen = $morph.attr("data-morph-open");

                handleSvg = function () {
                    if (!headerOpen) {
                        path.animate({'path': pathOpen}, 400, mina.easeinout, function () {
                        });
                    }
                    else {
                        path.animate({'path': initialPath}, 400, mina.easeinout, function () {
                        });
                    }
                }
            }
        }

        var headerToggleOnClick = function () {
            this.$body.toggleClass("header-is-open");
            if (this.options.header_position == "left" || this.options.header_position == "right") {
                this.$body.removeClass("header-sidebar-on");
                handleSvg();
            }
            headerOpen = !headerOpen;
            return false;
        }.bind(this);

        this.$headerToggle.off("click");
        this.$headerToggleMobile.off("click");

        this.$headerToggle.on("click", headerToggleOnClick);
        this.$headerToggleMobile.on("click", headerToggleOnClick);
    };

    theme.headerAdminBarOffset = function () {
        var isAdminBar = this.$body.hasClass("admin-bar");

        var barCheck = function () {
            if (this.$window.scrollTop() < 46) {
                this.$header.css("top", "88px");
                this.$mobileHeaderBar.css("top", "46px");
                this.$cartWrap.css("top", "46px");
                this.$searchWrap.css("top", "46px");
                this.$headerSidebar.css("top", "46px");
            }
            else {
                this.$header.css("top", "");
                this.$mobileHeaderBar.css("top", "");
                this.$cartWrap.css("top", "");
                this.$searchWrap.css("top", "");
                this.$headerSidebar.css("top", "");
            }
        }.bind(this);

        if (isAdminBar) {
            var barResizeCheck = function () {
                if (this.$window.width() >= 768) {
                    this.$header.css("top", "");
                    this.$mobileHeaderBar.css("top", "");
                    this.$cartWrap.css("top", "");
                    this.$searchWrap.css("top", "");
                    this.$headerSidebar.css("top", "");
                    this.$window.off("scroll", barCheck);
                }
                else {
                    this.$window.off("scroll", barCheck);
                    this.$window.on("scroll", barCheck);
                    barCheck();
                }
            }.bind(this);
            this.$window.on("debouncedresize", barResizeCheck);
            barResizeCheck();
        }
    };

    theme.headerSticky = function () {
        var _this = this,
            $window = this.$window,
            isMoving = false,
            isMobile = false,
            isAdminBar = this.$body.hasClass("admin-bar"),
            isHiding = false,
            isShown = false,
            headerHeight = this.$header.height(),
            relativeHeader = this.$header.css("position") == "relative",
            stickyBreakpoint = this.$window.height(),
            stickyCheck = function () {
            }
            ;

        switch (this.options.header_sticky_mode) {

            case "immediate":
                stickyBreakpoint = 0;
                break;

            case "scrollwindow":
                stickyBreakpoint = (function () {
                    return _this.$window.height();
                }());
                break;

            default:
                stickyBreakpoint = 0;
                break;

        }

        this.$header.waitForImages(function () {
            headerHeight = this.$header.height();

            switch (this.options.header_sticky_mode) {

                case "immediate":
                    stickyBreakpoint = 0;
                    break;

                case "scrollwindow":
                    stickyBreakpoint = (function () {
                        return _this.$window.height();
                    }());
                    break;

                default:
                    stickyBreakpoint = 0;
                    break;

            }
        }.bind(this));

        this.$window.on("resize", $.debounce(50, true, function () {
            headerHeight = this.$header.height();
            isMobile = !(this.$window.width() > 767);

            if (isMobile) {
                this.$body.removeClass("is-sticky");
                this.$header.css("transform", "translateX(100%)");
                if (relativeHeader) {
                    this.$wrapper.css("padding-top", "")
                }
            }
        }.bind(this)));

        isMobile = !(this.$window.width() > 767);

        stickyCheck = $.throttle(50, true, function () {

            if (!($window.width() > 767)) {
                this.$header.css("transform", "");


                return;
            }

            if (this.$window.scrollTop() > stickyBreakpoint) {
                if (this.options.header_sticky_mode == "scrollwindow") {
                    if (!isMoving && !isShown) {
                        this.$header.css("transition", "transform 0s linear");
                        this.$header.css("transform", "translateY(-100%)");

                        this.$body.addClass("is-sticky");

                        setTimeout(function () {
                            this.$header.css("transition", "transform 0.2s ease-in");
                            this.$header.css("transform", "translateY(0px)");
                        }.bind(this), 10);

                        setTimeout(function () {
                            isMoving = false;
                            isShown = true;
                        }, 500);
                        isMoving = true;
                    }
                }
                else {
                    this.$body.addClass("is-sticky");
                }
                if (relativeHeader) {
                    this.$wrapper.css("padding-top", headerHeight + "px")
                }
            }
            else {
                if (this.options.header_sticky_mode == "scrollwindow") {
                    if (!isHiding && isShown) {
                        setTimeout(function () {
                            this.$header.css("transition", "transform 0.1s ease-in");
                            this.$header.css("transform", "translateY(-100%)");
                        }.bind(this), 10);

                        setTimeout(function () {
                            isHiding = false;
                            isShown = false;
                            setTimeout(function () {
                                this.$body.removeClass("is-sticky");
                                setTimeout(function () {
                                    if (relativeHeader) {
                                        this.$wrapper.css("padding-top", "")
                                    }
                                    this.$header.css("transition", "transform 0s linear");
                                    this.$header.css("transform", "translateY(0)");
                                }.bind(this), 10);
                            }.bind(this), 10);
                        }.bind(this), 200);
                        isHiding = true;
                    }
                }
                else {
                    this.$body.removeClass("is-sticky");
                    if (relativeHeader) {
                        this.$wrapper.css("padding-top", "")
                    }
                }
            }
        }.bind(this));

        this.$window.off("scroll", stickyCheck);
        this.$window.on("scroll", stickyCheck);
    };

    theme.sideMenuLevels = function () {
        var mobileMenu = this.mobileMenu,
            header_click = !!(this.options.header_click),
            $parents = this.$menuWrap.find(".menu-item-has-children");

        $parents.each(function () {
            var $li = $(this),
                $ul = $li.find(">ul");

            // init
            $ul.css({
                "position": "absolute",
                "display": "block",
                "opacity": 0,
                "height": "auto"
            });

            if (header_click) {
                $li.on("click", function () {

                    var $item = $(this);

                    if (mobileMenu) {
                        return false;
                    }

                    var ulHeight;

                    if (!$item.hasClass("menu-level-open")) {
                        $item.addClass("menu-level-open");

                        $ul.css({
                            "position": "absolute",
                            "display": "block",
                            "opacity": 0,
                            "height": "auto"
                        });

                        ulHeight = $ul.height();

                        $ul.css({
                            "position": "relative",
                            "height": 0,
                            "opacity": 1
                        });
                        $ul.animate({
                            "height": ulHeight + 'px'
                        }, 400, function () {
                            $(this).css("height", "auto");
                        });
                    }
                    else {
                        $item.removeClass("menu-level-open");

                        $ul.animate({
                            "height": "0"
                        }, 400, function () {
                            $(this).css("display", "none");
                        });
                    }
                    return false;
                });
            }
            else {
                $li.hoverIntent({
                    over: function () {

                        if (mobileMenu) {
                            return;
                        }

                        var ulHeight;

                        $ul.css({
                            "position": "absolute",
                            "display": "block",
                            "opacity": 0,
                            "height": "auto"
                        });

                        ulHeight = $ul.height();

                        $ul.css({
                            "position": "relative",
                            "height": 0,
                            "opacity": 1
                        });
                        $ul.animate({
                            "height": ulHeight + 'px'
                        }, 400, function () {
                            $(this).css("height", "auto");
                        });
                    },
                    out: function () {

                        if (mobileMenu) {
                            return;
                        }

                        $ul.animate({
                            "height": "0"
                        }, 400, function () {
                            $(this).css("display", "none");
                        });
                    },
                    sensitivity: 3,
                    timeout: 1000
                });
            }
        });
    };

    theme.topMenuColumnLevels = function () {

        var mobileMenu = false,
            _this = this,
            $window = this.$window,
            $menuWrap = this.$menuWrap,
            header_click = !!(this.options.header_click),
            $topLevelParents = this.$menuWrap.find(".menu > .menu-item-has-children");

        var $parents = this.$menuWrap.find(".menu > li.menu-item-has-children"),
            $allParents = this.$menuWrap.find("li.menu-item-has-children");

        $topLevelParents.hoverIntent(function () {
                $(this).addClass("mouse-over");
            },
            function () {
                $(this).removeClass("mouse-over");
            });

        if (header_click) {
            $topLevelParents.on("click", function () {
                if ($(this).hasClass("menu-level-open")) {
                    $topLevelParents.removeClass("menu-level-open");
                }
                else {
                    $topLevelParents.removeClass("menu-level-open");
                    $(this).addClass("menu-level-open");
                }
                return false;
            })
        }

        $("li.columns-block > ul > li > a").on("click", function () {
            return false;
        });

        $window.on("debouncedresize", function () {
            mobileMenu = !($window.width() > 767);
            setTimeout(function () {
                resetMenuHovers();
            }, 1000);
        });

        mobileMenu = !($window.width() > 767);

        function resetMenuHovers() {

            var headerLeftPadding = Number(_this.$header.css("padding-left").replace("px", ""));

            /** clear all hovrIntents */
            $allParents.each(function () {
                var $li = $(this);

                $li.unbind("mouseenter").unbind("mouseleave");

                if ($li.prop('hoverIntent_t')) {
                    clearTimeout($li.prop('hoverIntent_t'));
                }
                $li.removeProp('hoverIntent_t');
                $li.removeProp('hoverIntent_s');

                $li.find(">ul.js-managed").css({
                    "overflow": "",
                    "position": "",
                    "display": "",
                    "opacity": "",
                    "height": "",
                    "max-width": "none"
                }).removeClass("js-managed hov-int");

                $menuWrap.find(".menu > li > ul").css({transform: "none"});
                $menuWrap.find(".menu > li.columns-block > ul").css({position: "absolute"});
            });

            setTimeout(function () {
                /* normal */

                if (!mobileMenu) {
                    $parents.each(function () {
                        var $columnBlock = $(this),
                            holderWidth,
                            $columnBlockUl,
                            parentOffset = $(this).prop("offsetLeft"),
                            menuWrapOffset = $("#menu-wrap").prop("offsetLeft"),
                            blockWidth,
                            offset,
                            $li = $(this).find("li.menu-item-has-children li.menu-item-has-children");

                        if (!$(this).hasClass("columns-block")) {
                            $li = $(this).find("li.menu-item-has-children");
                        }
                        else {
                            /** columns block */

                            $columnBlockUl = $columnBlock.find(">ul");
                            $columnBlockUl.css({
                                width: "",
                                "white-space": "nowrap"
                            });

                            setTimeout(function () {
                                holderWidth = $columnBlock.outerWidth();

                                blockWidth = $columnBlockUl.outerWidth();
                                offset = blockWidth / 2 - holderWidth / 2;

                                if (offset > ( parentOffset + menuWrapOffset + headerLeftPadding ) + holderWidth / 2) {
                                    offset = parentOffset + menuWrapOffset + headerLeftPadding;
                                    $columnBlockUl.css({
                                        "transform": "translateX(-" + offset + "px)"
                                    });

                                    if (blockWidth > $(window).width()) {
                                        $columnBlockUl.css({
                                            width: $(window).width(),
                                            "white-space": "normal"
                                        });
                                    }
                                    else {
                                        $columnBlockUl.css({
                                            width: "",
                                            "white-space": "nowrap"
                                        })
                                    }
                                }
                                else if(offset > ( parentOffset + menuWrapOffset + headerLeftPadding ) + holderWidth / 2){

                                }
                                else {
                                    $columnBlockUl.css({
                                        "transform": "translateX(-" + offset + "px)"
                                    });
                                }
                            }, 100);
                        }

                        $li.each(function () {
                            var $thisLi = $(this),
                                $ul = $thisLi.find(">.sub-menu");

                            $thisLi.addClass("hov-int");
                            $ul.addClass("js-managed");

                            // init
                            $ul.css({
                                "overflow": "hidden",
                                "position": "absolute",
                                "display": "block",
                                "opacity": 0,
                                "height": "auto"
                            });

                            if (header_click) {
                                $thisLi.on("click", function () {
                                    var $item = $(this);

                                    if (mobileMenu) {
                                        return false;
                                    }

                                    var ulHeight;

                                    if (!$item.hasClass("menu-level-open")) {
                                        $item.addClass("menu-level-open");

                                        $ul.css({
                                            "position": "absolute",
                                            "display": "block",
                                            "opacity": 0,
                                            "height": "auto",
                                            "max-width": 0
                                        });

                                        ulHeight = $ul.height();

                                        $ul.animate({
                                            "max-width": '500px'
                                        }, 150, function () {
                                            $ul.css({
                                                "position": "relative",
                                                "height": 0,
                                                "opacity": 1
                                            });
                                            $ul.animate({
                                                "height": ulHeight + 'px'
                                            }, 250, function () {
                                                $ul.css("height", "auto");
                                            });
                                        });
                                    }
                                    else {
                                        $item.removeClass("menu-level-open");
                                        $ul.animate({
                                            "height": "0"
                                        }, 250, function () {
                                            $ul.animate({
                                                "max-width": '0'
                                            }, 150, function () {
                                                $ul.css("display", "none");
                                            });
                                        });
                                    }
                                    return false;
                                });
                            }
                            else {
                                $thisLi.hoverIntent({
                                    over: function () {

                                        if (mobileMenu) {
                                            return false;
                                        }

                                        var ulHeight;

                                        $thisLi.addClass("mouse-over");

                                        $ul.css({
                                            "position": "absolute",
                                            "display": "block",
                                            "opacity": 0,
                                            "height": "auto",
                                            "max-width": 0
                                        });

                                        ulHeight = $ul.height();

                                        $ul.animate({
                                            "max-width": '500px'
                                        }, 150, function () {
                                            $ul.css({
                                                "position": "relative",
                                                "height": 0,
                                                "opacity": 1
                                            });
                                            $ul.animate({
                                                "height": ulHeight + 'px'
                                            }, 250, function () {
                                                $ul.css("height", "auto");
                                            });
                                        });
                                    },
                                    out: function () {

                                        if (mobileMenu) {
                                            return false;
                                        }

                                        $thisLi.removeClass("mouse-over");

                                        $ul.animate({
                                            "height": "0"
                                        }, 250, function () {
                                            $ul.animate({
                                                "max-width": '0'
                                            }, 150, function () {
                                                $ul.css("display", "none");
                                            });
                                        });
                                    },
                                    sensitivity: 3,
                                    timeout: 1000
                                });
                            }
                        });
                    });
                }
                else if (mobileMenu) {
                    /** mobile */

                    $allParents.each(function () {
                        var $li = $(this);

                        $li.each(function () {
                            var $thisLi = $(this),
                                $ul = $thisLi.find(">.sub-menu");

                            $thisLi.addClass("js-managed");
                            $ul.addClass("js-managed");

                            // init
                            if (mobileMenu) {
                                $ul.css({
                                    "overflow": "hidden",
                                    "position": "absolute",
                                    "display": "block",
                                    "opacity": 0,
                                    "height": "auto",
                                    "transform": "none"
                                });
                            }

                            $thisLi.hoverIntent(function () {

                                    if (!mobileMenu) {
                                        return false;
                                    }

                                    var ulHeight;

                                    $thisLi.addClass("mouse-over");

                                    $ul.css({
                                        "position": "absolute",
                                        "display": "block",
                                        "opacity": 0,
                                        "height": "auto",
                                        "max-width": 0
                                    });

                                    ulHeight = $ul.height();

                                    $ul.animate({
                                        "max-width": '500px'
                                    }, 150, function () {
                                        $ul.css({
                                            "position": "relative",
                                            "height": 0,
                                            "opacity": 1
                                        });
                                        $ul.animate({
                                            "height": ulHeight + 'px'
                                        }, 250, function () {
                                            $ul.css("height", "auto");
                                        });
                                    });
                                },
                                function () {

                                    if (!mobileMenu) {
                                        return false;
                                    }

                                    $thisLi.removeClass("mouse-over");

                                    $ul.animate({
                                        "height": "0"
                                    }, 250, function () {
                                        $ul.animate({
                                            "max-width": '0'
                                        }, 150, function () {
                                            $ul.css("display", "none");
                                        });
                                    });
                                }, {
                                    sensitivity: 3
                                })
                        });
                    });
                } // endif
            }, 50);

        } // resetMenuHovers
        resetMenuHovers();
    };

    theme.fsBlockHeight = function () {
        var $fsBlock = $("#fs-block"),
            plus = 0;

        if (this.$body.hasClass("admin-bar")) {
            plus = 32;
        }

        if ($fsBlock.length && this.$body.hasClass("header-not-transparent") && this.$body.hasClass("l-header-horizontal")) {
            $fsBlock.height(this.$window.height() - this.$header.outerHeight() - plus);
            $(window).on("debouncedresize", function () {
                $fsBlock.height(this.$window.height() - this.$header.outerHeight() - plus);
            }.bind(this));
            $fsBlock.height(this.$window.height() - this.$header.outerHeight() - plus);
        }
        else if ($fsBlock.length) {
            $(window).on("debouncedresize", function () {
                $fsBlock.height(this.$window.height() - plus);
            }.bind(this));
            $fsBlock.height(this.$window.height() - plus);
        }

    };

    theme.headerTransparency = function () {
        var flag = true,
            needToChangeSkin = false,
            fsSkinClass = "",
            headerSkinClass = "section-" + this.$header.attr("data-skin"),
            $fsBlock = $("#fs-block"),
            $fsBlockInner = $fsBlock.find(".fs-block-inner")
            ;

        if ($fsBlockInner.length && $fsBlockInner.attr("data-skin") && headerSkinClass != $fsBlockInner.attr("data-skin")) {
            needToChangeSkin = true;
            fsSkinClass = "section-" + $fsBlockInner.attr("data-skin");
        }

        var headerCheck = function () {
            if (this.$window.scrollTop() > 50) {
                if (flag) {
                    this.$body.removeClass("header-transparent");
                    flag = false;

                    if (needToChangeSkin) {
                        this.$header.removeClass(fsSkinClass).addClass(headerSkinClass);
                        this.$headerControls.removeClass(fsSkinClass).addClass(headerSkinClass);
                    }
                }
            }
            else {
                if (!flag) {
                    this.$body.addClass("header-transparent");
                    flag = true;

                    if (needToChangeSkin) {
                        this.$header.removeClass(headerSkinClass).addClass(fsSkinClass);
                        this.$headerControls.removeClass(headerSkinClass).addClass(fsSkinClass);
                    }
                }
            }
        }.bind(this);

        this.$window.on("scroll", $.throttle(150, headerCheck));

        /** initial check */
        if (this.$window.scrollTop() <= 50) {
            if (needToChangeSkin) {
                this.$header.removeClass(headerSkinClass).addClass(fsSkinClass);
                this.$headerControls.removeClass(headerSkinClass).addClass(fsSkinClass);
            }
        }
    };

    theme.headerSidebar = function () {
        var $sidebarClose = $("#sidebar-close"),
            $sidebarCloseMobile = $("#sidebar-close-mobile"),
            $sidebarOverlay = $("#sidebar-overlay");

        var sidebarOnClick = function () {
            this.$body.toggleClass("header-sidebar-on");
            if (this.options.header_position == "left" || this.options.header_position == "right") {
                this.$body.removeClass("header-is-open");
            }
            return false;
        }.bind(this);

        this.$headerSidebarBtn.on("click", sidebarOnClick);
        this.$headerSidebarBtnMobile.on("click", sidebarOnClick);

        $sidebarClose.on("click", function () {
            this.$body.removeClass("header-is-open");
            this.$body.removeClass("header-sidebar-on");
            return false;
        }.bind(this));

        $sidebarCloseMobile.on("click", function () {
            this.$body.removeClass("header-is-open");
            this.$body.removeClass("header-sidebar-on");
            return false;
        }.bind(this));

        $sidebarOverlay.on("click", function () {
            this.$body.removeClass("header-is-open");
            this.$body.removeClass("header-sidebar-on");
            return false;
        }.bind(this));
    };

    theme.headerSearch = function () {
        var $searchClose = $("#search-close"),
            restoreSidebar = false;

        var searchOnClick = function () {
            restoreSidebar = false;
            this.$body.addClass("header-search-on");
            if (this.$body.hasClass("header-sidebar-on")) {
                restoreSidebar = true;
                this.$body.removeClass("header-sidebar-on");
            }
            return false;
        }.bind(this);

        this.$headerSearchBtn.on("click", searchOnClick);
        this.$headerSearchBtnMobile.on("click", searchOnClick);

        $searchClose.on("click", function () {
            this.$body.removeClass("header-search-on");
            if (restoreSidebar) {
                this.$body.addClass("header-sidebar-on");
                restoreSidebar = false;
            }
            return false;
        }.bind(this));
    };

    theme.headerCart = function () {
        var $cartClose = $("#cart-close"),
            restoreSidebar = false;

        var cartOnClick = function () {
            restoreSidebar = false;
            this.$body.addClass("header-cart-on");
            if (this.$body.hasClass("header-sidebar-on")) {
                restoreSidebar = true;
                this.$body.removeClass("header-sidebar-on");
            }
            return false;
        }.bind(this);

        this.$headerCartBtn.on("click", cartOnClick);
        this.$headerCartBtnMobile.on("click", cartOnClick);

        $cartClose.on("click", function () {
            this.$body.removeClass("header-cart-on");
            if (restoreSidebar) {
                this.$body.addClass("header-sidebar-on");
                restoreSidebar = false;
            }
            return false;
        }.bind(this));
    };

    theme.initSkrollr = function () {
        var s = null,
            running = false
            ;

        function skrollrStart() {
            s = skrollr.init({
                smoothScrolling: false,
                forceHeight: false,
                mobileDeceleration: 0.004
            });
            running = true;
        }

        function skrollrQuit() {
            if (s && s.destroy && typeof s.destroy === 'function') {
                s.destroy();
            }
            running = false;
        }

        function manageSkrollr() {
            if ($(window).width() > 1024) {
                skrollrStart();
            }
            else {
                skrollrQuit();
            }
        }

        $(window).on("debouncedresize", manageSkrollr);
        manageSkrollr();
    };

    theme.initVideoHeader = function () {
        var $fsBlock = $("#fs-block"),
            $fsVideo = $fsBlock.find("#fs-video");

        if ($fsVideo.length) {
            $fsBlock.videoHelper({
                viewport: $fsBlock,
                onReady: function () {
                    ;
                },
                hideUs: [$(".header-content-wrap")]
            });
        }
    };

    theme.initCrumbsVideo = function () {
        var $videoCrumbs = $(".bg-type-video");

        $videoCrumbs.each(function () {
            var $wrap = $(this),
                $bgWrap = $wrap.find(".breadcrumbs-bg-wrap");

            $wrap.videoHelper({
                viewport: $bgWrap,
                auto: true,
                muted: true,
                mode: "fitViewport"
            });
        });
    };

    theme.initHeaderVideo = function () {
        if (this.$header.hasClass("header-bg-video")) {
            var $wrap = this.$header,
                $bgWrap = $wrap.find(".header-bg-wrap");

            $wrap.videoHelper({
                viewport: $bgWrap,
                auto: true,
                muted: true,
                mode: "fitViewport"
            });
        }
    };

    theme.initSliderVideo = function () {
        $(".ggt-slide.type-video").each(function () {
            var $wrap = $(this),
                $bgWrap = $wrap.find(".fs-block-movable");

            $wrap.videoHelper({
                viewport: $bgWrap,
                auto: true,
                muted: true,
                mode: "fitViewport"
            });
        });
    };

    theme.initWooEvents = function () {

        var $supports_html5_storage;

        // wc_cart_fragments_params is required to continue, ensure the object exists
        if (typeof wc_cart_fragments_params === 'undefined') {
            return false;
        }

        /** Cart Handling */
        try {
            $supports_html5_storage = ( 'sessionStorage' in window && window.sessionStorage !== null );

            window.sessionStorage.setItem('wc', 'test');
            window.sessionStorage.removeItem('wc');
        } catch (err) {
            $supports_html5_storage = false;
        }

        this.$body.on("wc_fragments_refreshed", function () {
            var wc_fragments = $.parseJSON(sessionStorage.getItem(wc_cart_fragments_params.fragment_name)),
                cart_hash = sessionStorage.getItem('wc_cart_hash'),
                cookie_hash = $.cookie('woocommerce_cart_hash');

            if (cart_hash === null || cart_hash === undefined || cart_hash === '') {
                cart_hash = '';
            }

            if (cookie_hash === null || cookie_hash === undefined || cookie_hash === '') {
                cookie_hash = '';
            }

            if (wc_fragments && wc_fragments['div.widget_shopping_cart_content']) {
                var $total = $(wc_fragments['div.widget_shopping_cart_content']).find(".total").find(".amount").html();
            }
        });

        this.$body.on("wc_fragments_loaded", function () {
            ;
        });

        this.$body.on("added_to_cart", function (event, fragments, cart_hash) {
            var $fragmentsContent = $(fragments["div.widget_shopping_cart_content"]),
                $cartCounter = $(".header-cart-info").find(".cart-count-number"),
                count = 0,
                allGood = true,
                $items = $fragmentsContent.find("li");

            $items.each(function () {
                var $qty = $(this).find(".quantity").clone(),
                    $txt = null,
                    res = null;

                $qty.find('span').remove();
                $txt = $qty.text();

                try {
                    res = Number($txt.replace(/×/, "").trim());
                    if (res) {
                        count += res;
                    }
                }
                catch (e) {
                    allGood = false;
                }
            });

            if (allGood) {
                $cartCounter.text(count);
            }
        });
    };

    theme.removePreloader = function () {
        var $loader = $("#theme-preloader"),
            $inner = $loader.find(".preloader-line"),
            $logo = $loader.find(".preloader-logo")
            ;

        $("#loadingbar").animate({
            width: "100%"
        }, 2000, "linear", function(){
            ;
        });

        setTimeout(function () {
            $inner.animate({
                opacity: "0"
            }, 200, "linear", function () {
                $inner.remove();
            });

            $logo.animate({
                opacity: "0"
            }, 200, "linear", function () {
                $logo.remove();
            });
        }, 2000);

        setTimeout(function () {

            $("body").addClass("loader-done");

            setTimeout(function () {
                $loader.animate({
                    opacity: "0"
                }, 1000, "linear", function () {
                    $loader.remove();
                });
            }, 1000);
        }, 2200);
    };

    theme.widthClasses = function () {
        var $body = this.$body,
            mobileMenu = this.mobileMenu,
            $window = this.$window;

        var setWidthClasses = function () {
            if ($window.width() <= 320) {
                $body.addClass("w320");
                $body.removeClass("w768 w767");
                $body.removeClass("desktop-menu");
                $body.addClass("mobile-menu");
                mobileMenu = true;
            }
            else if ($window.width() < 768) {
                $body.addClass("w767");
                $body.removeClass("w320 w768");
                $body.removeClass("desktop-menu");
                $body.addClass("mobile-menu");
                mobileMenu = true;
            }
            else if ($window.width() == 768) {
                $body.addClass("w768");
                $body.removeClass("w320 w767");
                $body.addClass("desktop-menu");
                $body.removeClass("mobile-menu");
                mobileMenu = false;
            } else {
                $body.addClass("desktop-menu");
                $body.removeClass("mobile-menu");
                mobileMenu = false;
            }
        };
        setWidthClasses();
        this.$window.on("resize", $.debounce(100, true, setWidthClasses));
    };

    theme.waitForUs = function () {

        var _this = this;

        FontLoader.referenceText += "\ue68e"; // ggticons character

        var fontLoader = new FontLoader(["ggticons"], {
            "fontsLoaded": function (error) {
                if (error !== null) {
                    // Reached the timeout but not all fonts were loaded
                } else {

                }
                _this.removePreloader();
            },
            "fontLoaded": function (fontFamily) {
                // One of the fonts was loaded
            }
        }, 10000);
        fontLoader.loadFonts();
    };

    theme.retinaImgs = function ($wrap) {

        $wrap = $wrap || $("body");

        if ((this.retina && $(window).width() > 1280) || $(window).width() > 1370) {

            $wrap.find('[data-hdpi-src]').each(function () {
                if ($(this).attr("data-hdpi-src")) {
                    if ($(this).hasClass("lazyload")) {
                        $(this).attr("data-original", $(this).attr("data-hdpi-src")); // for lazyload just change the data-original attr
                    }
                    else if ($(this).hasClass("lazyOwl")) {
                        $(this).attr("data-src", $(this).attr("data-hdpi-src")); // lazy Carousels
                    }
                    else {
                        if ($(this).prop("tagName") == 'IMG') { // images
                            $(this).attr("src", $(this).attr("data-hdpi-src"));
                        }
                        else { // divs, etc.
                            $(this).css("background-image", "url(" + $(this).attr("data-hdpi-src") + ")");
                        }
                    }
                }
            })
        }
    };

    theme.initLazyLoad = function ($wrap) {

        var multi = this.mobile ? 3 : 1.5,
            thresh = (function () {
                return multi * $(window).width();
            })();

        $wrap = $wrap || $("body");
        $wrap.find(".lazyload").each(function () {

            $(this).lazyload({
                threshold: thresh
            });
        })
    };

    theme.initCarousels = function ($wrap) {

        $wrap = $wrap || $("body");

        var owlData = {
            items: 1,
            singleItem: true,
            pagination: false,
            navigation: true,
            autoPlay: 7000,
            transitionStyle: "fade",
            lazyLoad: true,
            touchDrag: !this.mobile
        };

        $wrap.find(".owl-post-gallery").each(function () {
            var $owl = $(this);

            if ($owl.hasClass("owl-carousel")) return; // owl already running

            $owl.owlCarousel(
                owlData
            );
        })
    };

    theme.breadcrumbsElastic = function () {
        var $crumbs = this.$titleCrumbs,
            $elasticFrame = $crumbs.find(".elastic-frame"),
            $bgWrap = $crumbs.find(".breadcrumbs-bg-wrap"),
            testImage = new Image(),
            $window = this.$window,
            imageSrc = null;

        if ($elasticFrame.hasClass("image-type-elastic")) {
            imageSrc = $bgWrap.attr("data-bg-image");
            testImage.src = imageSrc;

            $elasticFrame.waitForImages(function () {

                var imgWidth = testImage.naturalWidth,
                    imgHeight = testImage.naturalHeight,
                    crumbsHeight = $crumbs.height(),
                    offsetTop = $crumbs.offset().top;

                $bgWrap.css({
                    "background-position": "50% " + offsetTop + "px"
                });

                function elasticCrumbsScroll() {
                    var top = offsetTop - $window.scrollTop();
                    if ($window.scrollTop() > offsetTop) {
                        top += ($window.scrollTop() - offsetTop) / 2;
                    }
                    $bgWrap.css({
                        "background-position": "50% " + top + "px"
                    });
                }

                function resetElastic() {
                    $window.off("scroll", elasticCrumbsScroll);
                    if ($window.width() > 1024) {
                        $window.on("scroll", elasticCrumbsScroll);
                        elasticCrumbsScroll();
                    }
                    else {
                        $bgWrap.css({
                            "background-position": "50% 50%"
                        });
                    }
                }

                $window.on("debouncedresize", resetElastic);
                resetElastic();
            });
        }
    };

    theme.initFitVids = function () {
        $("article.post").fitVids();
    };

    theme.backToTop = function () {
        var $b2top = $('#back2top');

        function b2top() {
            $('body,html').animate({
                scrollTop: 0
            }, 800);
            return false;
        }

        $b2top.off("click", b2top);
        $b2top.on("click", b2top);
    };

    theme.starRatingFix = function () {
        var $stars = $(".comment-form-rating").find(".stars");
        $stars.find("a").each(function () {
            $(this).append('<span class="before-fix"></span>');
        });
    };

    theme.selectTwoInit = function () {
        if (jQuery.fn.select2 && typeof jQuery.fn.select2 === 'function') {
            $("#calc_shipping_country").select2();
            $("select.orderby").select2();
        }
    };

    theme.initWooSliders = function () {
        if (!(this.$body.hasClass("archive")) && (this.$body.hasClass("ggt-is-woo"))) {
            return;
        }

        var _this = this,
            $woo = $("#woo-content"),
            $wooModal = $('<div class="ggt-woo-quickbuy-modal-wrap"><div class="ggt-woo-quickbuy-modal"><a href="#" class="ggt-woo-modal-close">x</a><div class="ggt-woo-quickbuy-modal-content col-lg-12 woocommerce single-product"></div></div></div>');

        $wooModal.find(".ggt-woo-modal-close").on("click", function () {
            $wooModal.removeClass("ggt-woo-modal-on");
            $wooModal.removeClass("woo-content-ready");
            $wooModal.find(".ggt-woo-quickbuy-modal-content").html("");
            return false;
        });

        $('body').append($wooModal);

        $woo.addClass("ggt-woo-carousel");

        $woo.each(function () {
            var $carousel = $(this),
                quickBuyText = $carousel.attr("data-quickbuy"),
                quickViewText = $carousel.attr("data-quickview"),
                crop = "cropped",
                $items = $carousel.find(".product"),
                ids = [];

            $items.each(function () {

                var $item = $(this),
                    $quickBuy = $item.find(".add_to_cart_button"),
                    $quickView = $('<a href="#" class="ggt-woo-quick-view"><i class="ggticon-Eye-2"></i></a>'),
                    id = $item.attr("data-id")
                    ;

                $quickView.off("click");
                $quickView.on("click", function () {
                    $.ajax({
                        type: "POST",
                        url: adminAjax,
                        data: {
                            action: "ggt_ajax_woo_get_product_quick_buy",
                            crop: crop,
                            product_id: id
                        },
                        error: function (response) {

                        },
                        success: function (response) {
                            var $html = $(response);

                            $html.find(".woocommerce-tabs").remove();
                            $html.find(".upsells").remove();
                            $html.addClass("product");
                            $wooModal.find(".ggt-woo-quickbuy-modal-content").append($html);
                            $wooModal.addClass("woo-content-ready");
                        }
                    });
                    $wooModal.addClass("ggt-woo-modal-on");
                    return false;
                });

                $quickView.attr("data-label", quickViewText);

                $quickBuy.text("").append('<i class="ggticon-Add-Basket"></i>');
                $quickBuy.attr("data-label", quickBuyText);

                $(this).append($quickView);

                $item.hoverIntent(function () {
                        $items.addClass("faded");
                        $item.removeClass("faded");
                    },
                    function () {
                        $items.removeClass("faded");
                    });
            });

            $carousel.find(".product").each(function () {
                ids.push(Number($(this).attr("data-id")));
            });

        });
    };

    theme.bottomHeaderAdjust = function () {
        if (this.options.header_position != "bottom") {
            return;
        }

        var hh = this.$header.outerHeight(),
            footerBottomPad = Number(this.$footer.css("padding-bottom").replace("px", "")),
            $fs = this.$body.find("#fs-block");

        /**
         * Footer margin adjust
         * @type {function(this:theme)|*}
         */
        var adjustFooter = function () {
            var hh = this.$header.outerHeight();

            if (this.$window.width() > 768) {
                this.$footer.css("margin-bottom", hh + "px");
            }
            else {
                this.$footer.css("margin-bottom", "");
            }
        }.bind(this);
        this.$window.on("debouncedresize", adjustFooter);
        adjustFooter();

        /**
         * Fullscreen header adjust
         */
        if ($fs.length) {
            var $fsContent = $fs.find(".header-content-outer");
            var adjustFSHeader = function () {
                var hh = this.$header.outerHeight(),
                    fsContentBottomPadding = Number($fsContent.css("padding-bottom").replace("px", ""));

                if (this.$window.width() > 768) {
                    $fs.css("padding-bottom", Number(hh + fsContentBottomPadding) + "px");
                }
                else {
                    $fs.css("padding-bottom", "");
                }
            }.bind(this);
            this.$window.on("debouncedresize", adjustFSHeader);
            adjustFSHeader();
        }
    };

    theme.setEqualHeight = function () {
        if ($.fn.matchHeight && typeof $.fn.matchHeight === "function") {
            $(".equal-height").each(function () {
                var $eh = $(this);
                $eh.children().matchHeight();
            });
        }
    };

    theme.setRowPadding = function () {

        /**
         * Fix rows
         */

        $(".vc_row").each(function () {
            var $row = $(this),
                rowPaddingTop = Number($row.css("padding-top").replace(" ", "").replace("!important", "").replace("px", "")),
                rowPaddingRight = Number($row.css("padding-right").replace(" ", "").replace("!important", "").replace("px", "")),
                rowPaddingBottom = Number($row.css("padding-bottom").replace(" ", "").replace("!important", "").replace("px", "")),
                rowPaddingLeft = Number($row.css("padding-left").replace(" ", "").replace("!important", "").replace("px", ""))
                ;

            function fixPaddings() {
                if ($(window).width() >= 768) {
                    $row.removeClass("mobile-padding");
                }
                else {
                    $row.addClass("mobile-padding");
                }
            }

            if (rowPaddingTop && rowPaddingRight && rowPaddingBottom && rowPaddingLeft) {
                $(window).on("debouncedresize", fixPaddings);
                fixPaddings();
            }
        });

        /**
         * Fix cols
         */

        $(".wpb_column").each(function () {
            var $col = $(this),
                colPaddingTop = Number($col.css("padding-top").replace(" ", "").replace("!important", "").replace("px", "")),
                colPaddingRight = Number($col.css("padding-right").replace(" ", "").replace("!important", "").replace("px", "")),
                colPaddingBottom = Number($col.css("padding-bottom").replace(" ", "").replace("!important", "").replace("px", "")),
                colPaddingLeft = Number($col.css("padding-left").replace(" ", "").replace("!important", "").replace("px", ""))
                ;

            function fixColPaddings() {
                if ($(window).width() >= 768) {
                    $col.removeClass("mobile-padding");
                }
                else {
                    $col.addClass("mobile-padding");
                }
            }

            if (colPaddingTop >= 50 && colPaddingRight >= 50 && colPaddingBottom >= 50 && colPaddingLeft >= 50) {
                $(window).on("debouncedresize", fixColPaddings);
                fixColPaddings();
            }
        })
    };

    theme.setHeaderMobileSkin = function () {
        var skin = this.$header.attr("data-skin");
        var setHeaderSkin = function () {
            if ($(window).width() < 768) {
                this.$header.removeClass("section-dark section-light").addClass("section-dark");
            }
            else {
                //this.$header.removeClass("section-dark section-light").addClass("section-" + skin);
            }
        }.bind(this);
        $(window).on("debouncedresize", setHeaderSkin);
        setHeaderSkin();
    };

    theme.mobileMenuClicksHandler = function () {
        this.$header.find(".menu-item-has-children > a").on("click", function () {
            return $(window).width() >= 768; // allow click on portrait tablet and up, disable on mobile
        });
    };

    theme.externalSliderSkinMap = function () {
        $(".ls-header").each(function () {
            var $lsHeader = $(this),
                $header = $("#site-header"),
                skinMap = JSON.parse($lsHeader.attr("data-skin-map"));

            $lsHeader.find(".ls-wp-container").layerSlider({
                cbInit: function (data) {
                    console.log("init ls");
                },
                cbAnimStart: function (data) {
                    console.log("ls next", data);
                    $header.removeClass("section-light section-dark").addClass("section-" + skinMap[data.curLayerIndex]);
                }
            });
            console.log(skinMap);
        })
    };

    theme.onReady = function () {

        this.mobile = !(this.$body.hasClass('desktop'));

        this.$body.addClass("doc-ready");

        var iOS = ( navigator.userAgent.match(/(iPad|iPhone|iPod)/g) ? true : false );
        var iPhone = ( navigator.userAgent.match(/(iPhone)/g) ? true : false );

        if (iOS) {
            this.$body.addClass("is-ios");
        }

        if (iPhone) {
            this.$body.addClass("is-iphone");
        }

        this.retinaImgs();

        this.headerToggleInit();
        if (this.options.header_sticky_switch && this.options.header_position == "top") {
            this.headerSticky();
        }

        if (this.options.header_sidebar_switch && this.$headerSidebarBtn.length) {
            this.headerSidebar();
        }

        if (this.options.header_search_switch && this.$headerSearchBtn.length) {
            this.headerSearch();
        }

        if (this.options.header_cart_switch && this.$headerCartBtn.length) {
            this.headerCart();
        }

        /** vertical menu */
        if (this.options.header_position == "left" || this.options.header_position == "right") {
            /** menu levels for side menu */
            this.sideMenuLevels();
        }
        else {
            this.topMenuColumnLevels();
        }

        if (this.options.header_transparent) {
            this.headerTransparency();
        }

        this.widthClasses();

        this.fsBlockHeight();
        this.initGGTSliders();
        this.initVideoHeader();
        this.initCrumbsVideo();
        this.initHeaderVideo();
        this.initSliderVideo();
        this.initWooEvents();
        this.initSkrollr();
        this.initWooSliders();
        this.bottomHeaderAdjust();
        this.headerAdminBarOffset();

        this.waitForUs();

        this.initLazyLoad();
        this.initCarousels();
        this.initFitVids();
        this.breadcrumbsElastic();
        this.backToTop();
        this.starRatingFix();
        this.selectTwoInit();
        this.setEqualHeight();
        this.setRowPadding();
        this.setHeaderMobileSkin();
        this.mobileMenuClicksHandler();
        this.externalSliderSkinMap();
    };

    theme.onLoad = function () {
        this.$body.addClass("win-load")
    };

    $(document).ready(function () {
        theme.onReady();
    });

    $(window).load(function () {
        theme.onLoad();
    });

}(jQuery));